import arcpy
from arcpy import env
#INPUT-mdb
mdb="D:\\20180416\\tool\\model.mdb"
env.workspace =mdb
#OUTPUT
result = "D:\\20180416\\result" 
# Process: Calculate Field
arcpy.CalculateField_management("m", "P", "rr( !P! )", "PYTHON_9.3", "def rr(a):\\n if(a is None):\\n  return 0\\n else:\\n  return a \\n")
# Process: Feature To Point
arcpy.FeatureToPoint_management("m", "m_FeatureToPoint", "INSIDE")
# Process: Point Distance
arcpy.PointDistance_analysis("m_FeatureToPoint", "m_FeatureToPoint", "m_FeatureToPoint_PointDis", "")
# Process: Table to Table
arcpy.TableToTable_conversion("m_FeatureToPoint_PointDis", mdb, "SDEI", "INPUT_FID < NEAR_FID", "INPUT_FID \"NewFieldName\" true true false 50 Text 0 0 ,First,#;NEAR_FID \"NewFieldName\" true true false 50 Text 0 0 ,First,#", "")
# Process: Add Field 
arcpy.AddField_management("SDEI", "P_INPUT", "DOUBLE", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
# Process: Add Field 
arcpy.AddField_management("SDEI", "P_NEAR", "DOUBLE", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
# Process: Join Field 
arcpy.JoinField_management("SDEI", "INPUT_FID","m", "OBJECTID", "P")
# Process: Calculate Field 
arcpy.CalculateField_management("SDEI", "P_INPUT", "[P]", "VB", "")
# Process: Delete Field 
arcpy.DeleteField_management("SDEI", "P")
# Process: Join Field 
arcpy.JoinField_management("SDEI", "NEAR_FID", "m", "OBJECTID", "P")
# Process: Calculate Field 
arcpy.CalculateField_management("SDEI", "P_NEAR", "[P]", "VB", "")
# Process: Delete Field 
arcpy.DeleteField_management("SDEI", "P")
# Process: Add Field 
arcpy.AddField_management("SDEI", "wij", "DOUBLE", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
# Process: Add Field 
arcpy.AddField_management("SDEI", "sqrt2dis", "DOUBLE", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
# Process: Add Field 
arcpy.AddField_management("SDEI", "wij_multiply_sqrt2dis", "DOUBLE", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
# Process: Calculate Field 
arcpy.CalculateField_management("SDEI", "sqrt2dis", "Sqr ( 2* [DISTANCE] )", "VB", "")
# Process: Calculate Field 
arcpy.CalculateField_management("SDEI", "wij", "rr( !P_INPUT! , !P_NEAR! )", "PYTHON_9.3", "def rr(a,b):\\n if(a!=0 and  b!=0):\\n  return -(a+b) *(a/(a+b) *math.log(a/(a+b),2 ) + b /(a+b) *math.log(b/(a+b) ,2 ) )\\n else:\\n  return  0\\n\\n\\n")
# Process: Calculate Field
arcpy.CalculateField_management("SDEI", "wij_multiply_sqrt2dis", "[wij] * [sqrt2dis]", "VB", "")
# Process: Summary Statistics
arcpy.Statistics_analysis("SDEI", "SDEI_Result", "sqrt2dis SUM;wij_multiply_sqrt2dis SUM")
# Process: Add Field 
arcpy.AddField_management("SDEI_Result", "SDEI", "DOUBLE", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
# Process: Dissolve
arcpy.Dissolve_management("m", "m_Dissolve", "", "OBJECTID COUNT", "MULTI_PART", "DISSOLVE_LINES")
# Process: Join Field
arcpy.JoinField_management("SDEI_Result", "OBJECTID", "m_Dissolve", "OBJECTID", "COUNT_OBJECTID")
# Process: Calculate Field 
arcpy.CalculateField_management("SDEI_Result", "SDEI", "[SUM_wij_multiply_sqrt2dis] /(2 * [SUM_sqrt2dis] / [COUNT_OBJECTID] )", "VB", "")
# Process: Table to dBASE (multiple)
arcpy.TableToDBASE_conversion("SDEI_Result", result)

print "finish"

